import java.util.Comparator; 
import java.util.Random;

class Point2d {
  double x, y; 
  
  public Point2d(double x, double y) {
    this.x = x;
    this.y = y;
  }
  
  public String toString() {
    return "(" + x + " , " + y + ")";
  }
  
  /**
   * Computes the square distance from this 
   * point to that one. Better to use this for comparing
   * distances than to use the actual distance because
   * this avoids the square-root function and rounding errors. 
   * 
   * @param that The point to compare to. 
   * @return The squared distance from this to that. 
   */
  double distSqTo(Point2d that) {
      double dx = that.x - this.x;
      double dy = that.y - this.y;
      return dx*dx + dy*dy;
  }
}

/** 
 * @return the mid-point of the line segment ab. 
 */
Point2d midPoint(Point2d a, Point2d b) {
  return new Point2d(0.5 * (a.x + b.x), 0.5 * (a.y + b.y));
}